<?php

/* ====================
[BEGIN_COT_EXT]
Hooks=standalone,ajax,index.tags
[END_COT_EXT]
==================== */

/**
 * Cotonti Minichat
 *
 * @package Cotonti
 * @version 1.00
 * @author esclkm
 * @copyright &copy; esclkm 2010
 */
/* @var $db CotDB */
/* @var $cache Cache */
/* @var $t Xtemplate */
defined('COT_CODE') OR die("Wrong URL.");
require_once cot_incfile('users', 'module');

require_once cot_incfile('forms');
//require_once cot_incfile('minichat', 'plug');
require_once cot_langfile('minichat', 'plug');

global $db_com, $db_x;
$db_com = (isset($db_com)) ? $db_com : $db_x . 'com';

require_once cot_incfile('comments', 'plug');
require_once cot_incfile('forms');
require_once cot_langfile('minichat', 'plug');

$template = (cot_import('panel', 'G', 'BOL') || $env['ext'] == 'index') ? ".index" : "";

/**
 * Builds minichat_box
 *
 * @param string $temlate Use temlate for minichat.
 * @param bool $ajax Use If loaded by ajax.
 * @param bool $jaxpagination Use If ajax paginated.
 * @return string
 */
function minichat_build($template, $ajax=false)
{
	global $usr, $error_string, $cfg, $db_com, $db_users, $L, $minichatt, $db, $sys;
	list($usr['auth_read_com'], $usr['auth_write_com'], $usr['isadmin_com']) = cot_auth('plug', 'minichat');

	$shoutbox = trim(cot_import('shoutbox', 'R', 'HTM'));

	if (!empty($shoutbox))
	{
		cot_shield_protect();
		$poster_name = $usr['name'];
		$poster_id = $usr['id'];
		$error_string .= ( mb_strlen($shoutbox) < $cfg['plugin']['minichat']['minichat_minchars']) ? $L['minichat_short_message']."<br />" : '';
		$error_string .= ( mb_strlen($shoutbox) > $cfg['plugin']['minichat']['minichat_maxchars']) ? $L['minichat_long_message']."<br />" : '';
		$error_string .= ( $poster_id == 0) ? $L['minichat_nouser_message']."<br />" : '';
		$error_string .= ( !$usr['auth_write_com']) ? $L['minichat_nowriterights']."<br />" : '';

		if (empty($error_string))
		{
			$db->insert($db_com, array('com_area' => 'chat', 'com_code' => 'chat',
				'com_author' => $poster_name, 'com_authorid' => (int)$poster_id, 'com_text' => $shoutbox,
				'com_date' => $sys['now_offset'], 'com_isspecial' => '1'));

			cot_shield_update(20, "New minichat message");
			$shoutbox = '';
			unset($_GET['shoutbox']);
		}
	}
	$delmcitem = cot_import('delmcitem', 'G', 'INT');
	if ($delmcitem > 0 && $usr['isadmin_com'])
	{
		$db->delete($db_com, "com_id='$delmcitem'");
		cot_log("Deleted minichat message #".$delmcitem."", 'adm');
		unset($_GET['delmcitem']);
	}

	$mskin = cot_tplfile('minichat'.$template, true);
	$minichatt = new XTemplate($mskin);

	if ($template != '')
	{
		$perpage = $cfg['plugin']['minichat']['minichat_recent'];
		$panelchat = "&panel=1";
	}
	else
	{
		$perpage = $cfg['plugin']['minichat']['minichat_maxperpage'];
		$panelchat = "";
	}
	$d_var = 'dmch';
	list($pg, $d, $durl) = cot_import_pagenav($d_var, $perpage);

	if (!$usr['auth_read_com'])
	{
		$error_string.=$L['minichat_noreadrights']."<br />";
	}

	if (!empty($error_string))
	{
		$minichatt->assign("MINICHAT_ERROR", $error_string);
		$minichatt->parse("MINICHAT.MINICHAT_ERRORBLOCK");
	}
	if ($usr['auth_read_com'])
	{
		$totalitems = $db->query("SELECT COUNT(*) FROM $db_com WHERE com_code='chat' ")->fetchColumn();

		$sql = $db->query("SELECT c.*, u.* FROM $db_com AS c LEFT JOIN $db_users AS u ON u.user_id = c.com_authorid WHERE com_area='chat' AND com_code='chat' ORDER BY com_id DESC LIMIT $d, $perpage ");
		$ii == 0;
		foreach ($sql->fetchAll() as $row)
		{
			$ii++;

			$minichatt->assign(array(
				"MINICHAT_ROW_ID" => $row['com_id'],
				"MINICHAT_ROW_AUTHOR" => cot_build_user($row['com_authorid'], $row['com_author']),
				"MINICHAT_ROW_TEXT" => cot_parse($row['com_text'], $cfg['plugin']['comments']['markup']),
				"MINICHAT_ROW_DATE" => cot_date('datetime_medium', $row['com_date'] + $usr['timezone'] * 3600),
				'MINICHAT_ROW_DATE_STAMP' => $row['com_date'] + $usr['timezone'] * 3600,
				"MINICHAT_ROW_ADMIN_URL" => ($usr['isadmin_com']) ? cot_url("plug", "e=minichat&delmcitem=".$row['com_id']) : '',
				"MINICHAT_ROW_ADMIN" => $minichat_admin,
				"MINICHAT_ROW_ADMIN_LITE" => $minichat_admin_lite,
			));
			$minichatt->assign(cot_generate_usertags($row, 'MINICHAT_ROW_AUTHOR_'), htmlspecialchars($row['com_author']));
			$minichatt->parse("MINICHAT.CHAT.MINICHAT_ROW");
		}
		$pagenav = cot_pagenav('plug', 'e=minichat', $d, $totalitems, $perpage, $d_var, '#minichatajax', $cfg['jquery'] && $cfg['ajax_enabled'], 'minichatajax', 'plug', "r=minichat".$panelchat);

		$minichatt->assign(array(
			"MINICHAT_PAGENAV" => $pagenav['main'],
			"MINICHAT_PREV" => $pagenav['prev'],
			"MINICHAT_NEXT" => $pagenav['next'],
		));
		
		if ($ii == 0)
		{
			$minichatt->parse("MINICHAT.CHAT.MINICHAT_EMPTY");
		}
		$minichatt->parse("MINICHAT.CHAT");
		if ($ajax)
		{
			$res = $minichatt->text("MINICHAT.CHAT");
			return $res;
		}
		
		if ($usr['auth_write_com'])
		{
			$minichatt->assign(array(
				"MINICHAT_FORM_SEND" => cot_url('plug', 'e=minichat'),
				"MINICHAT_FORM_TEXT" => $shoutbox,
			));
			$minichatt->parse("MINICHAT.MINICHAT_FORM");
		}

		$autoreloadtime = ($template != '') ? $cfg['plugin']['minichat']['minichat_recenttimer'] : $cfg['plugin']['minichat']['minichat_timer'];
		$minichatt->assign("MINICHAT_TIMER", $autoreloadtime);
		$minichatt->assign("MINICHAT_PANEL", ($template != '') ? 1 : 0);
		$minichatt->parse("MINICHAT");
		$res = $minichatt->text("MINICHAT");
	}

	return $res;
}


$MINICHAT = minichat_build($template, $r ? true : false);
if($r)
{
	cot_sendheaders();
	echo $MINICHAT;
}
else
{
	$t->assign("MINICHAT", $MINICHAT);
}

?>
